module time_subs
  !***********************************************************************
  ! Define derived types and related subroutines to handle time info
  !
  ! Larry Solheim Jun 2012
  !***********************************************************************

  use nccrip_params, only : time_units, time_interval
  use nccrip_params, only : usr_ib2_fmt, int_ib2_fmt
  use nccrip_params, only : int_ib2_year, int_ib2_mon
  use nccrip_params, only : time_units_attrib, gref_ymd_hms
  use nccrip_params, only : time_shift, dim_time_interval
  use nccrip_params, only : time_interval_secs
  use nccrip_params, only : time_offset_secs
  use nccrip_params, only : with_inv0
  use strings,       only : split_on_delim, tolower

  private

  public :: set_time, time_free, time_in_secs, parse_time_units
  public :: time_print
  public :: master_time, last_master_time
  public :: time_t, time_ptr_t

  !--- Define a derived type to hold time info
  type time_t
    !--- date and time as (Y,M,D,H,M,S)
    integer :: ymd_hms(6)

    !--- reference date and time as (Y,M,D,H,M,S)
    integer :: ref_ymd_hms(6)

    !--- time in seconds since reference date
    integer(kind=8) :: secs

    !--- dimensional time since reference date
    real(kind=8) :: time

    !--- dimensional time bounds
    real(kind=8), dimension(2) :: time_bnds

    !--- time units (e.g. days since 1850-1-1)
    character(len=40) :: units

    !--- A char string indicating the format of the ibuf2 value
    character(len=10) :: ib2_fmt

    !--- raw ibuf2 value
    integer(kind=8) :: ibuf2

    !--- time interval in seconds (assumed constant when used)
    integer(kind=8) :: interval_secs

    type(time_t), pointer :: prev => null()
    type(time_t), pointer :: next => null()
  end type time_t

  !--- Define a container to hold a pointer to time_t
  !--- which may be used to define an array of pointers
  type time_ptr_t
    type(time_t), pointer :: p => null()
  end type time_ptr_t

  !--- master_time is the head node of a list containing time
  !--- for the current open file
  type(time_t), save, pointer :: master_time

  !--- last_master_time is used to point to the end node of the master_time list
  type(time_t), save, pointer :: last_master_time

  contains

        subroutine time_free(self)
          !--- Free memory for a portion of the list (or the entire list)
          !--- starting at self and going to the end of the list
          implicit none
          type (time_t), pointer :: self, current, next

          current => self
          do while ( associated(current) )
            next => current%next
            deallocate( current )
            nullify( current )
            current => next
          enddo

          !--- Ensure we do not leave a pointer to deallocated space
          nullify( self )
        end subroutine time_free

        function time_find(onode, secs, ibuf2) result (found)
          !--- Find a node in the master_time list that has the same secs
          !--- and/or ibuf2 value as the input secs and ibuf2 values
          implicit none
          type (time_t), pointer :: onode, current, next
          integer(kind=8), intent(in), optional :: secs
          integer(kind=8), intent(in), optional :: ibuf2
          logical :: found, match(2)

          found=.false.
          if ( .not.present(secs) .and. .not.present(ibuf2) ) then
            write(6,*)"time_find: One of secs or ibuf2 must be present."
            call abort
          endif

          !--- If the master_time list is empty, return false
          if ( .not.associated(master_time) ) return

          current => master_time
          do while ( associated(current) )
            next => current%next

            match(:) = .false.
            if ( present(secs) ) then
              if ( current%secs .eq. secs ) match(1) = .true.
            else
              match(1) = .true.
            endif

            if ( present(ibuf2) ) then
              if ( current%ibuf2 .eq. ibuf2 ) match(2) = .true.
            else
              match(2) = .true.
            endif

            if ( all(match) ) then
              !--- Found a match
              onode => current
              found=.true.

              !--- Accept the first match
              return
            endif

            current => next
          enddo

        end function time_find

        subroutine time_init(self, ymd_hms, secs, time, time_bnds, &
                      ref_ymd_hms, units, ibuf2, interval_secs, ib2_fmt)
          !--- Initialize a list of type (time_t)
          implicit none
          type (time_t), pointer :: self
          integer, intent(in), optional :: ymd_hms(6)
          integer, intent(in), optional :: ref_ymd_hms(6)
          integer(kind=8), intent(in), optional :: secs
          integer(kind=8), intent(in), optional :: ibuf2
          integer(kind=8), intent(in), optional :: interval_secs
          real*8, intent(in), optional :: time, time_bnds(2)
          character*(*), intent(in), optional :: units, ib2_fmt

          if ( associated(self) ) then
            write(6,*) &
              'TIME_INIT: Attempting to initialize an existing node'
            call abort
          endif

          !--- Initialize the node and ensure it is the only node
          !--- in the list by setting next to NULL
          allocate(self)
          nullify( self%prev )
          nullify( self%next )

          if ( present(ymd_hms) ) then
            !--- Assign the date and time array
            self%ymd_hms(1:6) = ymd_hms(1:6)
          else
            self%ymd_hms(1:6) = -1
          endif

          if ( present(ref_ymd_hms) ) then
            !--- Assign the reference date and time array
            self%ref_ymd_hms(1:6) = ref_ymd_hms(1:6)
          else
            self%ref_ymd_hms(1:6) = -1
          endif

          if ( present(secs) ) then
            !--- Assign the secs
            self%secs = secs
          else
            self%secs = -1
          endif

          if ( present(ibuf2) ) then
            !--- Assign the ibuf2
            self%ibuf2 = ibuf2
          else
            self%ibuf2 = -1
          endif

          if ( present(interval_secs) ) then
            !--- Assign interval_secs
            self%interval_secs = interval_secs
          else
            self%interval_secs = -1
          endif

          if ( present(time) ) then
            !--- Assign dimensional time
            self%time = time
          else
            self%time = -1.d0
          endif

          if ( present(time_bnds) ) then
            !--- Assign dimensional time bounds
            self%time_bnds(1:2) = time_bnds(1:2)
          else
            self%time_bnds(1:2) = -1.d0
          endif

          if ( present(units) ) then
            !--- Assign time units (e.g.days since 1850-1-1)
            self%units = trim(adjustl(units))
          else
            self%units = " "
          endif

          if ( present(ib2_fmt) ) then
            !--- Assign ibuf2 format (e.g. YYYY,YYYYMM,...)
            self%ib2_fmt = trim(adjustl(ib2_fmt))
          else
            self%ib2_fmt = " "
          endif

        end subroutine time_init

        subroutine time_insert(self, ymd_hms, secs, time, time_bnds, &
                      ref_ymd_hms, units, ibuf2, interval_secs, ib2_fmt)
          !--- Insert a node into a list of type (time_t)
          implicit none
          type (time_t), pointer :: self
          integer, intent(in), optional :: ymd_hms(6)
          integer, intent(in), optional :: ref_ymd_hms(6)
          integer(kind=8), intent(in), optional :: secs
          integer(kind=8), intent(in), optional :: ibuf2
          integer(kind=8), intent(in), optional :: interval_secs
          real*8, intent(in), optional :: time, time_bnds(2)
          character*(*), intent(in), optional :: units, ib2_fmt

          !--- Local
          type (time_t), pointer :: next

          if ( .not. associated(self) ) then
            write(6,*)'TIME_INSERT: ' &
              //'Attempting to insert after a non-existant node'
            call abort
          endif

          !--- Initialize the node and ensure it is solitary
          allocate( next )
          nullify( next%prev )
          nullify( next%next )

          if ( present(ymd_hms) ) then
            !--- Assign the date and time array
            next%ymd_hms(1:6) = ymd_hms(1:6)
          else
            next%ymd_hms(1:6) = -1
          endif

          if ( present(ref_ymd_hms) ) then
            !--- Assign the reference date and time array
            next%ref_ymd_hms(1:6) = ref_ymd_hms(1:6)
          else
            next%ref_ymd_hms(1:6) = -1
          endif

          if ( present(secs) ) then
            !--- Assign the secs
            next%secs = secs
          else
            next%secs = -1
          endif

          if ( present(ibuf2) ) then
            !--- Assign the ibuf2
            next%ibuf2 = ibuf2
          else
            next%ibuf2 = -1
          endif

          if ( present(interval_secs) ) then
            !--- Assign the interval_secs
            next%interval_secs = interval_secs
          else
            next%interval_secs = -1
          endif

          if ( present(time) ) then
            !--- Assign dimensional time
            next%time = time
          else
            next%time = -1.d0
          endif

          if ( present(time_bnds) ) then
            !--- Assign dimensional time bounds
            next%time_bnds(1:2) = time_bnds(1:2)
          else
            next%time_bnds(1:2) = -1.d0
          endif

          if ( present(units) ) then
            !--- Assign time units (e.g.days since 1850-1-1)
            next%units = trim(adjustl(units))
          else
            next%units = " "
          endif

          if ( present(ib2_fmt) ) then
            !--- Assign ibuf2 format (e.g. YYYY,YYYYMM,...)
            next%ib2_fmt = trim(adjustl(ib2_fmt))
          else
            next%ib2_fmt = " "
          endif

          next%prev => self
          next%next => self%next
          self%next => next
        end subroutine time_insert

        subroutine time_append(self, last, ymd_hms, secs,time, time_bnds, &
                               ref_ymd_hms, units, ibuf2, interval_secs, ib2_fmt)
          !--- Append a node to a list of type (time_t)
          !--- Note: Most arguments are mandatory
          implicit none
          type (time_t), pointer :: self, last
          integer, intent(in) :: ymd_hms(6)
          integer(kind=8), intent(in) :: secs
          real*8, intent(in) :: time, time_bnds(2)
          integer, intent(in), optional :: ref_ymd_hms(6)
          integer(kind=8), intent(in), optional :: ibuf2
          integer(kind=8), intent(in), optional :: interval_secs
          character*(*), intent(in), optional :: units, ib2_fmt

          !--- Local
          type (time_t), pointer :: current

          !--- If this list has not been initialized, then do so now
          if ( .not.associated(self) ) then
            call time_init(self,ymd_hms,secs,time,time_bnds)
            if ( present(ref_ymd_hms) ) then
              call time_put(self, ref_ymd_hms=ref_ymd_hms)
            endif
            if ( present(units) ) then
              call time_put(self, units=units)
            endif
            if ( present(ibuf2) ) then
              call time_put(self, ibuf2=ibuf2)
            endif
            if ( present(interval_secs) ) then
              call time_put(self, interval_secs=interval_secs)
            endif
            if ( present(ib2_fmt) ) then
              call time_put(self, ib2_fmt=ib2_fmt)
            endif
            last => self
            return
          endif

          !--- Find the last node in the list
          last    => self
          current => self
          do while ( associated(current) )
            last    => current
            current => current%next
          enddo

          !--- Insert after the last node in the list
          call time_insert(last,ymd_hms,secs,time,time_bnds)
          last => last%next
          if ( present(ref_ymd_hms) ) then
            call time_put(last, ref_ymd_hms=ref_ymd_hms)
          endif
          if ( present(units) ) then
            call time_put(last, units=units)
          endif
          if ( present(ibuf2) ) then
            call time_put(last, ibuf2=ibuf2)
          endif
          if ( present(interval_secs) ) then
            call time_put(last, interval_secs=interval_secs)
          endif
          if ( present(ib2_fmt) ) then
            call time_put(last, ib2_fmt=ib2_fmt)
          endif

        end subroutine time_append

        subroutine time_put(self, ymd_hms, secs, time, time_bnds, &
                            ref_ymd_hms, units, ibuf2, interval_secs, ib2_fmt)
          !--- Put one or more time_t elements into an existing node
          !--- The arguments (except self) are optional but at least
          !--- one of them must be present

          implicit none

          type (time_t), pointer :: self
          integer, intent(in), optional :: ymd_hms(6)
          integer(kind=8), intent(in), optional :: secs
          real*8, intent(in), optional :: time, time_bnds(2)
          integer, intent(in), optional :: ref_ymd_hms(6)
          integer(kind=8), intent(in), optional :: ibuf2
          integer(kind=8), intent(in), optional :: interval_secs
          character*(*), intent(in), optional :: units, ib2_fmt

          !--- Local
          logical :: found

          !--- It is an error for the input node to not been initialized
          if ( .not.associated(self) ) then
            write(6,*)'time_put: *** ERROR *** Input node is uninitialized.'
            call abort
          endif

          found=.false.

          if ( present(ymd_hms) ) then
            self%ymd_hms = ymd_hms
            found=.true.
          endif

          if ( present(secs) ) then
            self%secs = secs
            found=.true.
          endif

          if ( present(time) ) then
            self%time = time
            found=.true.
          endif

          if ( present(time_bnds) ) then
            self%time_bnds = time_bnds
            found=.true.
          endif

          if ( present(ref_ymd_hms) ) then
            self%ref_ymd_hms = ref_ymd_hms
            found=.true.
          endif

          if ( present(units) ) then
            self%units = units
            found=.true.
          endif

          if ( present(ibuf2) ) then
            self%ibuf2 = ibuf2
            found=.true.
          endif

          if ( present(interval_secs) ) then
            self%interval_secs = interval_secs
            found=.true.
          endif

          if ( present(ib2_fmt) ) then
            self%ib2_fmt = ib2_fmt
            found=.true.
          endif

          if (.not. found) then
            write(6,*)'time_put: At least one optional parameter is required.'
            call abort
          endif

        end subroutine time_put

        subroutine time_print(self,noisy,pfx)
          !--- Print info found in one node of a (time_t) list
          implicit none
          type (time_t), pointer :: self
          integer, intent(in), optional :: noisy
          character(*), intent(in), optional :: pfx

          !--- local
          character(len=64) :: str1, str2, str3
          integer :: lnoisy

          if ( .not.associated(self) ) then
            write(6,*)'TIME_PRINT: Uninitialized node'
            call abort
          endif

          if ( present(noisy) ) then
            lnoisy = noisy
          else
            lnoisy = 0
          endif

          if (lnoisy.gt.0) write(6,'(a)')'---------------'
          str1=" "
          write(str1,'(i6.4,"-",i2.2,"-",i2.2)') self%ymd_hms(1:3)
          str2=" "
          write(str2,'(i2.2,":",i2.2,":",i2.2)') self%ymd_hms(4:6)
          str3=" "
          write(str3, &
            '(a,i4.4,"-",i2.2,"-",i2.2,1x,i2.2,":",i2.2,":",i2.2)') &
            " seconds since ",self%ref_ymd_hms(1:6)

          if ( present(pfx) ) then
            write(6,'(a,$)')trim(pfx)
          endif

          if (lnoisy.lt.0) then
            write(6,'(3x,a,2x,a)')trim(str1),trim(str2)
            !--- Stop here
            return
          endif

          if (lnoisy.eq.0) then
            write(6,'(2x,a,2x,2a,i10,2a)')trim(str1),trim(str2), &
              '    ibuf2=',self%ibuf2,'  ib2fmt=',trim(adjustl(self%ib2_fmt))
          else
            write(6,'(2x,a,2x,a,i14,2a,i10,2a)')trim(str1), &
              trim(str2),self%secs,trim(str3), &
              '  ibuf2=',self%ibuf2,'  ib2fmt=',trim(adjustl(self%ib2_fmt))
          endif

          if (lnoisy.gt.0) then
            if ( present(pfx) ) then
              write(6,'(2a,1pg17.8,1x,2a,1p2g17.8)') &
                trim(pfx),'   time: ',self%time,trim(self%units), &
                '     bounds: ',self%time_bnds(:)
            else
              write(6,'(a,1pg17.8,1x,2a,1p2g17.8)') &
                '   time: ',self%time,trim(self%units), &
                '     bounds: ',self%time_bnds(:)
            endif
          endif

        end subroutine time_print

        subroutine time_print_list(self)
          !--- Print info for all nodes found in a (time_t) list
          implicit none
          type (time_t), pointer :: self
          type (time_t), pointer :: current

          if ( .not.associated(self) ) then
            write(6,*)'time_print_list: Input list is not associated.'
            return
          endif

          current => self
          do while ( associated(current) )
            call time_print( current )
            if ( .not.associated(current%next) ) exit
            current => current%next
          enddo

        end subroutine time_print_list

        subroutine set_time(this_time, ibuf, verbose, var_ib2_fmt, &
                            verbatim_ib2, use_master_time)
!***********************************************************************
! Determine year,month,day,hour from the ibuf2 value and
! set the current dimensional time and time bounds
!***********************************************************************

          !--- Model parameters
          use nccrip_params, only : delt, ocn_delt

          implicit none

          type (time_t), pointer :: this_time
          integer, intent(in) :: ibuf(8)
          integer, intent(in), optional :: verbose
          !--- var_ib2_fmt is a variable specific ib2_fmt that, if present,
          !--- will superceed any other ib2_fmt
          character(*), intent(in), optional :: var_ib2_fmt
          logical, intent(in), optional :: verbatim_ib2
          logical, intent(in), optional :: use_master_time

          !--- Local
          logical :: new_master_time, found
          real(kind=8) :: time, time_bnds(2)
          integer(kind=8) :: ibuf2, int8, interval_secs
          logical :: lverbatim_ib2, luse_master_time

          real(kind=8) :: doy
          integer :: lverbose=0
          integer :: nc4to8
          external   nc4to8
          real :: local_delt
          character(64) :: strng
          character(4)  :: vname, kind

          !--- The format of ibuf(2)
          !--- Valid values:  MODEL, YYYY, YYYYMM, YYYYMMDD, YYYYMMDDHH, RAW
          character(len=10) :: ib2_fmt = ' '

          integer(kind=8), parameter :: sec_per_year = 31536000
          integer(kind=8), parameter :: sec_per_day  =    86400
          integer(kind=8), parameter :: sec_per_hour =     3600
          integer(kind=8), parameter :: sec_per_min  =       60
          integer(kind=8), parameter :: one = 1
          integer(kind=8) :: time_secs, dim_time_secs, ref_time_secs
          integer(kind=8) :: time_bnds_secs(2), dim_time_bnds_secs(2)
          integer :: mode, ymd_hms(6), ref_ymd_hms(6)

          !--- number of days since Jan 1 0:0:0 to the start of each month
          integer, dimension(12) :: som = &
            (/ 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 /)

          !--- Determine year,month,dom,hour from the ibuf2 value and
          !--- set the current time and time bounds in days since epoch

          if ( present(verbose) ) then
            lverbose = verbose
          else
            lverbose = 0
          endif

          if ( present(verbatim_ib2) ) then
            lverbatim_ib2 = verbatim_ib2
          else
            lverbatim_ib2 = .false.
          endif

          if ( present(use_master_time) ) then
            luse_master_time = use_master_time
          else
            luse_master_time = .true.
          endif

          !--- Get a char representation of the CCCma variable name and kind of record
          kind  = transfer(ibuf(1),kind)
          vname = transfer(ibuf(3),vname)

          if ( time_offset_secs /= 0 ) with_inv0 = .false.

          if ( (ibuf(2).le.0 .and. with_inv0) .or. &
               kind.eq."LABL" .or. kind.eq."CHAR" ) then
            !--- When ibuf2 is <= 0 assume this is an invariant field.
            !--- If the record type is one of LABL or CHAR then the
            !--- ibuf2 value is always meaningless. For these cases
            !--- hard code the reference date/time and units and set time=0
            time = 0.d0
            time_bnds = (/ -1.d0, 1.d0 /)
            ymd_hms = (/0,1,1,0,0,0/)
            dim_time_secs = 0
            ibuf2 = ibuf(2)

            !--- If the current time already exists in the master_time list
            !--- then point this_time at the existing node
            found = time_find(this_time, secs=dim_time_secs, ibuf2=ibuf2)

            if (.not.found) then
              !--- If the current time does not exists in the master_time list
              !--- then add a node to the master_time list and point
              !--- this_time at the newly created node
              call time_append(master_time, last_master_time, ymd_hms, &
                  dim_time_secs, time, time_bnds, &
                  ref_ymd_hms=ymd_hms, units="1", ibuf2=ibuf2)
              this_time => last_master_time
            endif

            return
          endif

          !--- Initialize
          time         =  0.d0
          time_bnds(1) = -1.d0
          time_bnds(2) =  1.d0

          !--- ibuf2_time requires this parameter to be 8 bytes
          ibuf2 = ibuf(2)

          !--- Initialize interval_secs to the global value, which may or may not be set
          !--- Currently, this is only used for TIME records and is reset below, if required
          interval_secs = time_interval_secs

          !--- Detemine the reference time in seconds from the global gref_ymd_hms array
          call ymd2secs(gref_ymd_hms, ref_time_secs)

          if ( present(var_ib2_fmt) ) then
            !--- A variable specific ib2_fmt has been passed into this routine
            !--- Always use this value when it is present
            ib2_fmt = trim(var_ib2_fmt)
            if ( trim(adjustl(ib2_fmt)) .ne. "YYYY"       .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMM"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDD"   .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDDHH" .and. &
                 trim(adjustl(ib2_fmt)) .ne. "MODEL"      .and. &
                 trim(adjustl(ib2_fmt)) .ne. "OMODEL"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "DOY"        .and. &
                 trim(adjustl(ib2_fmt)) .ne. "RAW" ) then
              write(6,*)'set_time: Invalid variable specific ib2_fmt --> ', &
                trim(var_ib2_fmt),' <--'
              call abort
            endif

          else if ( len_trim(usr_ib2_fmt).gt.0 ) then
            !--- Assume the user knows what they want
            ib2_fmt = trim(usr_ib2_fmt)
            if ( trim(adjustl(ib2_fmt)) .ne. "YYYY"       .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMM"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDD"   .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDDHH" .and. &
                 trim(adjustl(ib2_fmt)) .ne. "MODEL"      .and. &
                 trim(adjustl(ib2_fmt)) .ne. "OMODEL"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "DOY"        .and. &
                 trim(adjustl(ib2_fmt)) .ne. "RAW" ) then
              write(6,*)'set_time: Invalid user supplied ib2_fmt --> ', &
                trim(usr_ib2_fmt),' <--'
              call abort
            endif

          else if ( len_trim(int_ib2_fmt).gt.0 ) then
            !--- The ibuf2 value has been set elsewhere
            ib2_fmt = trim(int_ib2_fmt)
            if ( trim(adjustl(ib2_fmt)) .ne. "YYYY"       .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMM"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDD"   .and. &
                 trim(adjustl(ib2_fmt)) .ne. "YYYYMMDDHH" .and. &
                 trim(adjustl(ib2_fmt)) .ne. "MODEL"      .and. &
                 trim(adjustl(ib2_fmt)) .ne. "OMODEL"     .and. &
                 trim(adjustl(ib2_fmt)) .ne. "DOY"        .and. &
                 trim(adjustl(ib2_fmt)) .ne. "RAW" ) then
              write(6,*)'set_time: Invalid internal ib2_fmt --> ', &
                trim(int_ib2_fmt),' <--'
              call abort
            endif

          else
            !--- If the user has not explicitly supplied a format
            !--- and the format has not been defined elsewhere then
            !--- default to "RAW" format
            ib2_fmt = 'RAW'
          endif

          if ( .not. lverbatim_ib2 .and. trim(adjustl(ib2_fmt)) .eq. "YYYYMM" ) then
            !--- The YYYYMM format may need to be treated differently in certain cases
            if ( int_ib2_year .gt. 0 .and. int_ib2_mon .gt. 0 ) then
              !--- Use these internal year/mon values to define ibuf2
              !--- This is required when ibuf2 does not contain a
              !--- meaningful value, such as in gp or xp files
              if (int_ib2_mon.lt.1 .or. int_ib2_mon.gt.12) then
                write(6,'(a,i4)')'set_time: Month is out of range. mon = ',int_ib2_mon
                call abort
              endif
              ibuf2 = 100*int_ib2_year + int_ib2_mon
            endif
            if (ibuf2.lt.101 .or. ibuf2.gt.999912) then
              !--- ibuf2=101    (year    1 month  1) is the minimum value allowed for this format
              !--- ibuf2=999912 (year 9999 month 12) is the maximum value allowed for this format
              write(6,'(a,i10)')'set_time: Invalid YYYYMM ibuf2 value = ',ibuf2
              call abort
            endif
          endif

          if ( kind .eq. "TIME" ) then
            !--- TIME records need special treatment
            !--- The input ibuf2 value must indicate the time at the start of the TIME record
            !--- and be in YYYYMMDDHH format
            ib2_fmt = 'YYYYMMDDHH'
            !--- Use the reference date as the origin for this TIME record
            !--- The time_t variable (this_time) defined below will be offset
            !--- from this date if the user has defined time_offset
            int8 = ref_time_secs
            call secs2ymd(int8, ymd_hms)
            ibuf2 = 1000000*ymd_hms(1) + 10000*ymd_hms(2) + 100*ymd_hms(3) + ymd_hms(4)

            !--- For TIME records the time interval must contain a meaningful value
            if ( interval_secs .le. 0 ) then
              !--- The user has not supplied an explicit value on the command line
              !--- Set the value here to be 1 unit of time,
              !--- whatever that is currently defined to be
              strng = " "
              strng = "1 "//trim(time_units)
              interval_secs = time_in_secs( trim(strng) )
            endif

            if (lverbose.gt.10) then
              write(6,'(2(a,i14),a,i10)')'ref_time_secs = ',ref_time_secs, &
                '  interval_secs = ',interval_secs,'  ibuf2 = ',ibuf2
            endif

          endif

          !--- Is delt for the ocn or the atm
          local_delt = delt
          if (trim(adjustl(ib2_fmt)) .eq. "OMODEL") then
            !--- If ib2fmt is OMODEL then local_delt MUST be ocean time step
            !--- otherwise delt is assumed to be model time step
            local_delt = ocn_delt
          endif

          !--- mode =  0 means return the "point" value
          !--- mode = -1 means return a value half an interval before the "point" value
          !--- mode =  1 means return a value half an interval after the "point" value
          !---          The interval is determined by the value of ib2_fmt
          !---          ib2_fmt = MODEL      => interval is delt
          !---          ib2_fmt = YYYYMMDDHH => interval is hour
          !---          ib2_fmt = YYYYMMDD   => interval is day
          !---          ib2_fmt = YYYYMM     => interval is month
          !---          ib2_fmt = YYYY       => interval is year
          !--- The bounds returned in time_bnds_secs will be
          !--- plus or minus half this interval

          if ( time_shift .ne. -99 ) then
            !--- the user has supplied a value for mode
            mode = time_shift
          else
            !--- Set the value of mode according to the value of ib2_fmt
            if ( trim(adjustl(ib2_fmt)) .eq. "YYYY" .or. &
                 trim(adjustl(ib2_fmt)) .eq. "YYYYMM" ) then
              !--- Monthly and yearly data is usually averaged
              mode = 1
            else
              !--- Otherwise assume the "point" value (e.g. instantaneous value)
              mode = 0
            endif
          endif

!---DBG---          lverbose=11
!---DBG---          write(6,'(a,$)')' ib2_fmt = '
!---DBG---          read(5,*)ib2_fmt
!---DBG--- 100      write(6,'(a,$)')' ibuf2,mode = '
!---DBG---          read(5,*)ibuf2,mode

          !--- Get time info from the ibuf(2) value
          call ibuf2_time(ibuf2, ib2_fmt, local_delt, time_secs, &
                          bnd_sec=time_bnds_secs, &
                          mode=mode, &
                          ymd_hms=ymd_hms, &
                          offset_secs=time_offset_secs, &
                          ibuf=ibuf)

          !--- Use the reference time together with the value of the global
          !--- variable time_units to calculate dimensional time
          dim_time_secs = time_secs - ref_time_secs
          dim_time_bnds_secs(1) = time_bnds_secs(1) - ref_time_secs
          dim_time_bnds_secs(2) = time_bnds_secs(2) - ref_time_secs
          if ( trim(adjustl(time_units)) .eq. "years" ) then
            time = dble(dim_time_secs)/dble(sec_per_year)
            time_bnds(1)=dble(dim_time_bnds_secs(1))/dble(sec_per_year)
            time_bnds(2)=dble(dim_time_bnds_secs(2))/dble(sec_per_year)
          else if ( trim(adjustl(time_units)) .eq. "days" ) then
            time = dble(dim_time_secs)/dble(sec_per_day)
            time_bnds(1)=dble(dim_time_bnds_secs(1))/dble(sec_per_day)
            time_bnds(2)=dble(dim_time_bnds_secs(2))/dble(sec_per_day)
          else if ( trim(adjustl(time_units)) .eq. "hours" ) then
            time = dble(dim_time_secs)/dble(sec_per_hour)
            time_bnds(1)=dble(dim_time_bnds_secs(1))/dble(sec_per_hour)
            time_bnds(2)=dble(dim_time_bnds_secs(2))/dble(sec_per_hour)
          else if ( trim(adjustl(time_units)) .eq. "minutes" ) then
            time = dble(dim_time_secs)/dble(sec_per_min)
            time_bnds(1)=dble(dim_time_bnds_secs(1))/dble(sec_per_min)
            time_bnds(2)=dble(dim_time_bnds_secs(2))/dble(sec_per_min)
          else if ( trim(adjustl(time_units)) .eq. "seconds" ) then
            time = dble(dim_time_secs)
            time_bnds(1)=dble(dim_time_bnds_secs(1))
            time_bnds(2)=dble(dim_time_bnds_secs(2))
          else
            write(6,*)'set_time: Invalid time units --> ', &
              trim(time_units),' <--'
            call xit("SET_TIME",-4)
          endif

          if ( dim_time_interval .gt. 0 ) then
            !--- A dimensional time interval has been calculated elsewhere
            if ( trim(adjustl(ib2_fmt)) .ne. "YYYYMM" ) then
              !--- Use this value to determine time bounds unless this is monthly data
              time_bnds(1)=time - dim_time_interval/2.d0
              time_bnds(2)=time + dim_time_interval/2.d0
            endif
          endif

          if (lverbose.gt.5) then
            write(6,'(1x,3a,i12)') &
              "---------- ib2_fmt = ",trim(ib2_fmt),'  ibuf2 = ',ibuf2
            strng = " "
            int8 = mod(time_secs, sec_per_day)
            doy  = dble(int8)/dble(sec_per_day)
            write(6,'(a4,1x,a,3i8,i12,1x,f10.4,3x,1pg20.12,a)') &
              ibuf(3),': CURRENT TIME year,mon,day,secs,doy,time: ', &
              ymd_hms(1),ymd_hms(2),ymd_hms(3),time_secs,doy,time, &
              trim(strng)
            call flush(6)
          endif

          if ( trim(ib2_fmt) .eq. "RAW" ) then
            !--- In this case the actual ibuf2 value is used as the time value
            dim_time_secs = time_secs
            time = dble(time_secs)
            time_bnds(1)=dble(time_secs)
            time_bnds(2)=dble(time_secs)
          endif

          if ( luse_master_time ) then
            !--- If the current time is present in the master_time list then point
            !--- this_time to that element of master time, otherwise append the
            !--- curretn time to the master_time list
 
            !--- If the current time already exists in the master_time list
            !--- then point this_time at the existing node
            found = time_find(this_time, secs=dim_time_secs, ibuf2=ibuf2)

            if (.not.found) then
              !--- If the current time does not exists in the master_time list
              !--- then add a node to the master_time list and point
              !--- this_time at the newly created node

              if ( trim(ib2_fmt) .eq. "RAW" ) then
                !--- This is a special case
                !--- Hard code the reference date/time and units
                call time_append(master_time, last_master_time, ymd_hms, &
                    dim_time_secs, time, time_bnds, &
                    ref_ymd_hms=(/0,1,1,0,0,0/), units="1", &
                    ibuf2=ibuf2, ib2_fmt=ib2_fmt, &
                    interval_secs=interval_secs )
              else
                !--- Otherwise set dimenional time as determined above
                call time_append( master_time, last_master_time, ymd_hms, &
                    dim_time_secs, time, time_bnds, &
                    ref_ymd_hms=gref_ymd_hms, &
                    units=trim(time_units_attrib), &
                    ibuf2=ibuf2, ib2_fmt=ib2_fmt, &
                    interval_secs=interval_secs )
              endif

              !--- last_master_time is created by time_append
              this_time => last_master_time

              if (lverbose.gt.10) then
                write(6,'(a,a4,1x,i10,1x,a4,1x,5i8,a)') &
                  "NEW DATE/TIME --> ",ibuf(1:8)," <--"
              endif
              if (lverbose.gt.10) then
                strng = " "
                write(strng,'(3a)')"NEW DATE/TIME for ",vname," "
                call time_print(this_time, noisy=0, pfx=trim(strng))
              endif
            endif

          else
            !--- Always append the time to the master_time list

            if ( associated(last_master_time) ) then
              !--- this_time should point to the last node in
              !--- the master time list if is exists
              this_time => last_master_time
            else
              !--- Otherwise nullify this_time
              this_time => master_time
            endif

            if ( trim(ib2_fmt) .eq. "RAW" ) then
              !--- This is a special case
              !--- Hard code the reference date/time and units
              call time_append(this_time, last_master_time, ymd_hms, &
                  dim_time_secs, time, time_bnds, &
                  ref_ymd_hms=(/0,1,1,0,0,0/), units="1", &
                  ibuf2=ibuf2, ib2_fmt=ib2_fmt, &
                  interval_secs=interval_secs )
            else
              !--- Otherwise set dimenional time as determined above
              call time_append( this_time, last_master_time, ymd_hms, &
                  dim_time_secs, time, time_bnds, &
                  ref_ymd_hms=gref_ymd_hms, &
                  units=trim(time_units_attrib), &
                  ibuf2=ibuf2, ib2_fmt=ib2_fmt, &
                  interval_secs=interval_secs )
            endif

            !--- We want to return the new value of last_master_time that
            !--- was assigned in the previous call to time_append
            this_time => last_master_time

            if (lverbose.gt.10) then
              write(6,'(a,a4,1x,i10,1x,a4,1x,5i8,a)') &
                "NEW DATE/TIME --> ",ibuf(1:8)," <--"
            endif
            if (lverbose.gt.10) then
              strng = " "
              write(strng,'(3a)')"NEW DATE/TIME for ",vname," "
              call time_print(this_time, noisy=0, pfx=trim(strng))
            endif

          endif

!---DBG---          goto 100

        end subroutine set_time

        subroutine ibuf2_time(ib2, ib2fmt, delt, secs, bnd_sec, &
                              mode, ymd_hms, offset_secs, ibuf)
!***********************************************************************
! Determine time from an ibuf(2) value.
! Time is returned as seconds since the start of year zero.
!
! Input:
!    ib2    ...input ibuf2 value
!    ib2fmt ...format of ib2 (e.g. YYYMM or MODEL or YYYMMDDHH etc)
!    delt   ...model time step in seconds (only used when fmt is MODEL)
!    mode   ...an integer flag that can affect return time value
! Output:
!    secs    ...total number of seconds since the start of year zero
!    bnd_sec ...lower and upper bounds on time, in seconds (optional)
!    ymd_hms ...date and time corresponding to secs (optional)
!***********************************************************************
          implicit none

          integer(kind=8) :: ib2
          character(*) :: ib2fmt
          real :: delt
          integer(kind=8) :: secs
          integer(kind=8), optional :: bnd_sec(2)
          integer, optional :: mode
          integer, optional :: ymd_hms(6)
          integer(kind=8), optional :: offset_secs
          integer, optional :: ibuf(8)

          !--- Local
          integer :: lmode
          integer(kind=8) :: idelt, total_secs, dt, doy, part_secs
          integer(kind=8) :: year, mon, day, hour, min, sec
          integer(kind=8), parameter :: sec_per_year = 31536000
          integer(kind=8), parameter :: sec_per_day  =    86400
          integer(kind=8), parameter :: sec_per_hour =     3600
          integer(kind=8), parameter :: sec_per_min  =       60
          integer(kind=8), parameter :: one = 1
          integer :: idx, verbose=1

          !--- number of days since Jan 1 0:0:0 to the start of each month
          integer(kind=8), save, dimension(12) :: som_day = &
          (/ 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 /)

          !--- number of days since Jan 1 0:0:0 to the end of each month
          integer(kind=8), save, dimension(12) :: eom_day = &
          (/ 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 /)

          !--- number of days in each month
          integer(kind=8), save, dimension(12) :: days_in_month = &
          (/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)

          !--- number of seconds since Jan 1 0:0:0 to the start of each month
          integer(kind=8), save, dimension(12) :: som_sec = &
          (/ 0,2678400,5097600,7776000,10368000,13046400,15638400, &
             18316800,20995200,23587200,26265600,28857600 /)

          !--- number of seconds in each month
          integer(kind=8), save, dimension(12) :: lom_sec = &
          (/ 2678400, 2419200, 2678400, 2592000, 2678400, 2592000, &
             2678400, 2678400, 2592000, 2678400, 2592000, 2678400 /)

!-----------------------------------------------------------------------

          !--- ib2 must be positive or zero
          if (ib2.lt.0) then
            write(6,*)'ibuf2_time: ib2=',ib2,' is out of range'
            write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
            call xit("ibuf2_time",-1)
          endif

          !--- Set a default value of zero for mode
          if ( present(mode) ) then
            lmode = mode
          else
            lmode = 0
          endif

          !--- mode must be one of -1, 0, 1
          if (lmode.lt.-1 .or. lmode.gt.1) then
            write(6,*)"ibuf2_time: mode=",lmode," is out of range"
            write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
            call xit("ibuf2_time",-2)
          endif

!--- fmt = RAW or blank ---
          if (len_trim(ib2fmt) .le. 0 .or. &
              trim(adjustl(ib2fmt)) .eq. "RAW") then
            !--- Use the ibuf2 values unmodified
            !--- In this case the return value of sec is the ibuf2 value
            secs = ib2

            if ( present(bnd_sec) ) then
              !--- The bounds are undefined in this case but return
              !--- them as the ibuf2 if present
              bnd_sec(1) = ib2
              bnd_sec(2) = ib2
            endif

            if ( present(ymd_hms) ) then
              !--- The date and time is also undefined but reinitialize
              !--- this array if present
              ymd_hms(1) = 0
              ymd_hms(2) = 1
              ymd_hms(3) = 1
              ymd_hms(4) = 0
              ymd_hms(5) = 0
              ymd_hms(6) = 0
            endif

            !--- Do nothing more in this routine
            return

!--- fmt = MODEL ---
          else if (trim(adjustl(ib2fmt)) .eq. "MODEL" .or. &
                   trim(adjustl(ib2fmt)) .eq. "OMODEL" .or. &
                   trim(adjustl(ib2fmt)) .eq. "ACCMODEL") then
            !--- ibuf2 is number of model time steps

            if (delt.le.0.0) then
              write(6,*)"ibuf2_time: ib2fmt = ",trim(ib2fmt)
              write(6,*)"ibuf2_time: delt=",delt," is out of range"
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-3)
            endif

            idelt = nint(delt)

            if ( time_interval_secs .gt. 0 ) then
              dt = time_interval_secs/2
            else
              dt = idelt/2
            endif

            !--- Define year such that year = 1 when
            !---   0 <= (ib2 * delt) <= (sec_per_year - 1)
            !--- that is, time origin is 1-1-1 0:0:0

            !--- The return value of secs is seconds since 1-1-1 0:0:0
            if (lmode.eq.0) then
              !--- Return the value from ib2 "as is"
              secs = ib2*idelt + sec_per_year
            else if ( lmode.eq.-1) then
              !--- Return a mid point value (0.5 delt before the "as is" value)
              secs = ib2*idelt + sec_per_year - dt
            else if ( lmode.eq.1) then
              !--- Return a mid point value (0.5 delt after the "as is" value)
              secs = ib2*idelt + sec_per_year + dt
            endif

            if ( present(bnd_sec) ) then
              !--- Define lower and upper bounds in seconds
              !--- When fmt=MODEL this will be +- delt/2
              bnd_sec(1) = secs - dt
              bnd_sec(2) = secs + dt
            endif

!--- fmt = YYYYMMDDHH ---
          else if (trim(adjustl(ib2fmt)) .eq. "YYYYMMDDHH" .or. &
                   trim(adjustl(ib2fmt)) .eq.  "YYYMMDDHH" .or. &
                   trim(adjustl(ib2fmt)) .eq.   "YYMMDDHH") then
            !--- ib2 will contain YYYYMMDDHH values
            year=ib2/1000000_8

            mon=(ib2-year*1000000_8)/10000_8
            if (mon.lt.1 .or. mon.gt.12) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid month=",mon
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-4)
            endif

            day=(ib2-year*1000000_8-mon*10000_8)/100_8
            if (day.lt.1 .or. day.gt.days_in_month(mon)) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid day=",day
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-5)
            endif

            hour=ib2-year*1000000_8-mon*10000_8-day*100_8
            if (hour.lt.0 .or. hour.gt.24) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid hour=",hour
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-6)
            endif

            if ( time_interval_secs .gt. 0 ) then
              dt = time_interval_secs/2
            else
              dt = sec_per_hour/2
            endif

            if (lmode.eq.0) then
              !--- Return the value from ib2 "as is"
              secs = year*sec_per_year + som_sec(mon) + &
                       (day-1)*sec_per_day  + hour*sec_per_hour
            else if (lmode.eq.-1) then
              !--- Return a mid point value (0.5 hours before the "as is" value)
              secs = year*sec_per_year + som_sec(mon) + &
                       (day-1)*sec_per_day  + hour*sec_per_hour - dt
            else if (lmode.eq.1) then
              !--- Return a mid point value (0.5 hours after the "as is" value)
              secs = year*sec_per_year + som_sec(mon) + &
                       (day-1)*sec_per_day  + hour*sec_per_hour + dt
            endif

            if ( present(bnd_sec) ) then
              !--- Define lower and upper bounds in seconds
              !--- When fmt=YYYYMMDDHH this will be +- sec_per_hour/2
              bnd_sec(1) = secs - dt
              bnd_sec(2) = secs + dt
            endif

!--- fmt = YYYYMMDD ---
          else if (trim(adjustl(ib2fmt)) .eq. "YYYYMMDD" .or. &
                   trim(adjustl(ib2fmt)) .eq.  "YYYMMDD" .or. &
                   trim(adjustl(ib2fmt)) .eq.   "YYMMDD") then
            !--- ib2 will contain YYYYMMDD values
            year = ib2/10000_8

            mon  = (ib2-year*10000_8)/100_8
            if (mon.lt.1 .or. mon.gt.12) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid month=",mon
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-7)
            endif

            day = ib2 - year*10000_8 - mon*100_8
            if (day.lt.1 .or. day.gt.days_in_month(mon)) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid day=",day
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-8)
            endif

            if ( time_interval_secs .gt. 0 ) then
              dt = time_interval_secs/2
            else
              dt = sec_per_day/2
            endif

            if (lmode.eq.0) then
              !--- Return the value from ib2 "as is"
              secs = year*sec_per_year + som_sec(mon) + &
                            (day-1)*sec_per_day
            else if (lmode.eq.-1) then
              !--- Return a mid point value (0.5 days before the "as is" value)
              secs = year*sec_per_year + som_sec(mon) + &
                            (day-1)*sec_per_day - dt
            else if (lmode.eq.1) then
              !--- Return a mid point value (0.5 days after the "as is" value)
              secs = year*sec_per_year + som_sec(mon) + &
                            (day-1)*sec_per_day + dt
            endif

            if ( present(bnd_sec) ) then
              !--- Define lower and upper bounds in seconds
              !--- When fmt=YYYYMMDD this will be +- sec_per_day/2
              bnd_sec(1) = secs - dt
              bnd_sec(2) = secs + dt
            endif

!--- fmt = YYYYMM ---
          else if (trim(adjustl(ib2fmt)) .eq. "YYYYMM" .or. &
                   trim(adjustl(ib2fmt)) .eq.  "YYYMM" .or. &
                   trim(adjustl(ib2fmt)) .eq.   "YYMM") then
            !--- ib2 will contain YYYYMM values
            year = ib2/100_8

            mon  = ib2 - year*100_8
            if (mon.lt.1 .or. mon.gt.12) then
              write(6,'(3a,i10)')"ibuf2_time: ib2fmt = ",trim(ib2fmt),"  ibuf2 = ",ib2
              write(6,*)"ibuf2_time: Invalid month=",mon
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-9)
            endif

            if (lmode.eq.0) then
              !--- Return the value from ib2 "as is"
              secs = year*sec_per_year + som_sec(mon)

              if ( present(bnd_sec) ) then
                !--- Define lower and upper bounds in seconds
                !--- When fmt=YYYYMM this will be +- len_of_curr_month/2
                !--- Since the "as is" value is on a month boundary, the lower
                !--- bound will be half the previous month and the upper bound
                !--- will be half the next month.
                !--- These two increments will not be the same in general.

                if ( time_interval_secs .gt. 0 ) then
                  dt = time_interval_secs/2
                else
                  if (mon.eq.1) then
                    dt = lom_sec(12)/2
                  else
                    dt = lom_sec(mon-1)/2
                  endif
                endif
                bnd_sec(1) = secs - dt

                if ( time_interval_secs .gt. 0 ) then
                  dt = time_interval_secs/2
                else
                  dt = lom_sec(mon)/2
                endif
                bnd_sec(2) = secs + dt
              endif

            else if (lmode.eq.-1) then
              !--- Return a mid point value (0.5 months before the "as is" value)
              if ( time_interval_secs .gt. 0 ) then
                dt = time_interval_secs/2
              else
                if (mon.eq.1) then
                  dt = lom_sec(12)/2
                else
                  dt = lom_sec(mon-1)/2
                endif
              endif
              secs = year*sec_per_year + som_sec(mon) - dt

              if ( present(bnd_sec) ) then
                !--- Define lower and upper bounds in seconds
                !--- When fmt=YYYYMM this will be +- len_of_curr_month/2
                bnd_sec(1) = secs - dt
                bnd_sec(2) = secs + dt
              endif

            else if (lmode.eq.1) then
              !--- Return a mid point value (0.5 months after the "as is" value)
              if ( time_interval_secs .gt. 0 ) then
                dt = time_interval_secs/2
              else
                dt = lom_sec(mon)/2
              endif
              secs = year*sec_per_year + som_sec(mon) + dt

              if ( present(bnd_sec) ) then
                !--- Define lower and upper bounds in seconds
                !--- When fmt=YYYYMM this will be +- len_of_curr_month/2
                bnd_sec(1) = secs - dt
                bnd_sec(2) = secs + dt
              endif
            endif

!--- fmt = YYYY ---
          else if (trim(adjustl(ib2fmt)) .eq. "YYYY" .or. &
                   trim(adjustl(ib2fmt)) .eq.  "YYY" .or. &
                   trim(adjustl(ib2fmt)) .eq.   "YY") then
            !--- ib2 will contain the year
            year = ib2

            if ( time_interval_secs .gt. 0 ) then
              dt = time_interval_secs/2
            else
              dt = sec_per_year/2
            endif

            if (lmode.eq.0) then
              !--- Return the value from ib2 "as is"
              secs = year*sec_per_year
            else if (lmode.eq.-1) then
              !--- Return a mid point value (0.5 years before the "as is" value)
              secs = year*sec_per_year - dt
            else if (lmode.eq.1) then
              !--- Return a mid point value (0.5 years after the "as is" value)
              secs = year*sec_per_year + dt
            endif

            if ( present(bnd_sec) ) then
              !--- Define lower and upper bounds in seconds
              !--- When fmt=YYYYMMDD this will be +- sec_per_year/2
              bnd_sec(1) = secs - dt
              bnd_sec(2) = secs + dt
            endif

          else
            write(6,*)'ibuf2_time: Invalid ibuf2 format ',trim(ib2fmt)
            write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
            call xit("ibuf2_time",-10)
          endif

          if ( present(offset_secs) ) then
            !--- Add this offset to the time in seconds calculated above
            secs = secs + offset_secs

            if (verbose.gt.20 .and. offset_secs.ne.0) then
              write(6,'(a,i12,a,i12,a)')'ibuf2_time: Adding time offset of ', &
                offset_secs,' secs to get new time ',secs,' secs'
            endif

            if ( present(bnd_sec) ) then
              !--- Add this offset to the time bounds (in seconds) calculated above
              bnd_sec(1) = bnd_sec(1) + offset_secs
              bnd_sec(2) = bnd_sec(2) + offset_secs
            endif
          endif

          if ( present(ymd_hms) ) then
            !--- Determine mon, day, hour, min, sec from secs (total seconds)

            year = secs/sec_per_year

            !--- Set part_secs to the number of seconds in the last partial year
            part_secs = mod(secs, sec_per_year)

            !--- current day of the year, as int
            doy = one + part_secs/sec_per_day

            mon=0
            do idx=1,12
              if (doy.le.eom_day(idx)) then
                mon=idx
                exit
              endif
            enddo
            if (mon.lt.1 .or. mon.gt.12) then
              write(6,*)'ibuf2_time: Unable to determine month'
              write(6,'(a4,1x,i10,1x,a4,1x,5i8)')ibuf(1:8)
              call xit("ibuf2_time",-11)
            endif

            !--- Determine day of the current month as int
            day = doy - som_day(mon)

            !--- Set dt to the number of seconds in the last partial day
            !--- and the determine partial H,M,S for this day
            dt = mod(part_secs, sec_per_day)
            hour = dt/sec_per_hour
            min  = (dt - hour*sec_per_hour)/sec_per_min
            sec  = dt - hour*sec_per_hour - min*sec_per_min

            !--- Assign the output array
            ymd_hms(1) = year
            ymd_hms(2) = mon
            ymd_hms(3) = day
            ymd_hms(4) = hour
            ymd_hms(5) = min
            ymd_hms(6) = sec

            if (verbose.gt.5) then
              write(6,'(a,i10,a,i4,a,i2,a,i2,3(a,i2))') &
                "ibuf2_time: ib2=",ib2, &
                "    Y=",year," M=",mon," D=",day, &
                "  H=",hour," M=",min," S=",sec
            endif
          endif

        end subroutine ibuf2_time

  subroutine ymd2secs(ymd_hms, secs)
    !--- Determine total seconds from year, mon, day, hour, min, sec
    use nccrip_params, only : verbose
    implicit none

    integer :: ymd_hms(6)
    integer(kind=8) :: secs

    !--- Local
    integer(kind=8), parameter :: sec_per_year = 31536000
    integer(kind=8), parameter :: sec_per_day  =    86400
    integer(kind=8), parameter :: sec_per_hour =     3600
    integer(kind=8), parameter :: sec_per_min  =       60
    !--- number of days since Jan 1 0:0:0 to the start of each month
    integer, parameter, dimension(12) :: som = &
      (/ 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 /)

    secs =     ymd_hms(1)   *sec_per_year + &
           som(ymd_hms(2))  *sec_per_day  + &
              (ymd_hms(3)-1)*sec_per_day  + &
               ymd_hms(4)   *sec_per_hour + &
               ymd_hms(5)   *sec_per_min  + &
               ymd_hms(6)

    if (verbose.gt.10) then
      write(6,'(a,i14,a,i4,5(a,i2.2))') "ymd2secs:  secs=",secs, &
        "   ",ymd_hms(1),"-",ymd_hms(2),"-",ymd_hms(3), &
          " ",ymd_hms(4),":",ymd_hms(5),":",ymd_hms(6)
    endif
  end subroutine ymd2secs

  subroutine secs2ymd(secs, ymd_hms)
    !--- Determine year, mon, day, hour, min, sec from total seconds
    use nccrip_params, only : verbose
    implicit none

    integer(kind=8) :: secs
    integer :: ymd_hms(6)

    !--- Local
    integer(kind=8), parameter :: sec_per_year = 31536000
    integer(kind=8), parameter :: sec_per_day  =    86400
    integer(kind=8), parameter :: sec_per_hour =     3600
    integer(kind=8), parameter :: sec_per_min  =       60
    integer(kind=8), parameter :: one = 1

    integer(kind=8) :: dt, doy, part_secs
    integer(kind=8) :: year, mon, day, hour, min, sec
    integer :: idx

    !--- number of days since Jan 1 0:0:0 to the start of each month
    integer(kind=8), save, dimension(12) :: som_day = &
      (/ 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 /)

    !--- number of days since Jan 1 0:0:0 to the end of each month
    integer(kind=8), save, dimension(12) :: eom_day = &
      (/ 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 /)

    year = secs/sec_per_year

    !--- Set part_secs to the number of seconds in the last partial year
    part_secs = mod(secs, sec_per_year)

    !--- current day of the year, as int
    doy = one + part_secs/sec_per_day

    mon=0
    do idx=1,12
      if (doy.le.eom_day(idx)) then
        mon=idx
        exit
      endif
    enddo
    if (mon.lt.1 .or. mon.gt.12) then
      write(6,'(a)')'secs2ymd: Unable to determine month'
      call abort
    endif

    !--- Determine day of the current month as int
    day = doy - som_day(mon)

    !--- Set dt to the number of seconds in the last partial day
    !--- and the determine partial H,M,S for this day
    dt = mod(part_secs, sec_per_day)
    hour = dt/sec_per_hour
    min  = (dt - hour*sec_per_hour)/sec_per_min
    sec  = dt - hour*sec_per_hour - min*sec_per_min

    !--- Assign the output array
    ymd_hms(1) = year
    ymd_hms(2) = mon
    ymd_hms(3) = day
    ymd_hms(4) = hour
    ymd_hms(5) = min
    ymd_hms(6) = sec

    if (verbose.gt.10) then
      write(6,'(a,i14,a,i4,5(a,i2.2))') "secs2ymd:  secs=",secs, &
        "   ",year,"-",mon,"-",day," ",hour,":",min,":",sec
    endif
  end subroutine secs2ymd

  function time_in_secs(time_in) result (time_secs)
    !---------------------------------------------------------
    !--- Return the time in seconds given a string of the form
    !---     N years|days|hours|minutes|seconds
    !---------------------------------------------------------
    implicit none

    character*(*)   :: time_in
    integer(kind=8) :: time_secs

    !--- local
    character(len=64) :: units, strng, word(10)
    integer :: idx1, nword, ios
    real(kind=8) :: n_units
    integer(kind=8), parameter :: sec_per_year = 31536000
    integer(kind=8), parameter :: sec_per_day  =    86400
    integer(kind=8), parameter :: sec_per_hour =     3600
    integer(kind=8), parameter :: sec_per_min  =       60

    !--- The input time_in must be a string of the form
    !---    N Units
    !--- where N is numeric and Units is one of "years", "days", "hours", "minutes"
    !--- or "seconds". Certain abreviations of these units are allowed

    if (len_trim(time_in).le.0) then
      write(6,*)"time_in_secs: Empty input string"
      call xit("TIME_IN_SECS",-1)
    endif

    !--- Make everything lower case to simplify the comparisons done below
    strng = " "
    call tolower(time_in,strng)

    !--- Remove any leading white space that may appear in time_in
    strng = adjustl(strng)

    !--- Separate the time_in string on white space into an array of words
    call split_on_delim(word,nword,strng," ")

    if (nword.lt.2) then
      !--- There must be at least 2 space separated words in the input string
      write(6,*)"time_in_secs: Too few words in time input string."
      write(6,*)"   ",trim(time_in)
      write(6,*)"It must be of the form --> N years|days|hours|minutes|seconds <--"
      call xit("TIME_IN_SECS",-2)
    endif

    !--- Process each word to extract the time as seconds
    do idx1=1,nword
      select case (idx1)
        case (1)
          !--- This should be the number of units
          strng = trim(adjustl(word(idx1)))
          read(strng,*,iostat=ios)n_units
          if (ios.ne.0) then
            write(6,*)'Error ',ios,' reading internal file ',trim(strng)
            call xit("TIME_IN_SECS",-3)
          endif
        case (2)
          !--- This should be the units string
          units = " "
          units = trim(word(idx1))
          !--- Set units explicitly in the following case statement so
          !--- that regardless of the abbreviation, units will always
          !--- contain a know string which may be compared later on
          select case (trim(adjustl(units)))
            case ("y", "yr", "yrs", "year", "years")
              !--- Convert years to seconds
              time_secs = nint(n_units * sec_per_year, 8)
            case ("d", "day", "days")
              !--- Convert days to seconds
              time_secs = nint(n_units * sec_per_day, 8)
            case ("h", "hr", "hrs", "hour", "hours")
              !--- Convert hours to seconds
              time_secs = nint(n_units * sec_per_hour, 8)
            case ("m", "min", "mins", "minute", "minutes")
              !--- Convert minutes to seconds
              time_secs = nint(n_units * sec_per_min, 8)
            case ("s", "sec", "secs", "second", "seconds")
              !--- Convert seconds to seconds
              time_secs = nint(n_units, 8)
            case default
              !--- Invalid time units
              write(6,'(3a)')"time_in_secs: Invalid time units --> ", &
                trim(time_in)," <--"
              write(6,'(a)') &
                " The second word must be one of years, days, hours, minutes, seconds."
              call xit("TIME_IN_SECS",-4)
          end select
        case default
          !--- Too many words
          write(6,*)"time_in_secs: Too many words found in time input string."
          write(6,*)"   ",trim(time_in)
          write(6,*)"It must be of the form --> N years|days|hours|minutes|seconds <--"
          call xit("TIME_IN_SECS",-5)
      end select
    enddo

  end function time_in_secs

  subroutine parse_time_units(time_units_in)
    !-----------------------------------------------------------------------
    !--- Extract info about time units and time origin from the input string
    !-----------------------------------------------------------------------

    implicit none

    character*(*) :: time_units_in

    !--- local
    character(len=64) :: units, strng, word(10), numb(10)
    integer :: idx1, idx2, idx3
    logical :: ok
    integer :: year, mon, day, hour, min, sec, nword, nnumb

    !--- The input time_units_in must be a string of the form
    !---    U since Y-M-D H:M:S
    !--- where U is one of "days", "hours", "minutes" or "seconds"
    !--- certain abbreviations of these units are allowed

    if (len_trim(time_units_in).le.0) then
      write(6,*)"parse_time_units: Empty input string"
      call xit("PARSE_TIME_UNITS",-1)
    endif

    !--- Initialize variables that may be set below
    units=" "
    year=0
    mon=1
    day=1
    hour=0
    min=0
    sec=0

    !--- Make everything lower case to simplify the comparisons done below
    strng = " "
    call tolower(time_units_in,strng)

    !--- Remove any leading white space in time_units_in
    strng = adjustl(strng)

    !--- Separate the time_units_in string on white space into an array of words
    !--- call str2list(time_units_in,64," ",word,nword,4)
    call split_on_delim(word,nword,strng," ")

    if (nword.lt.3) then
      !--- The "U since Y-M-D" portion of the attribute string is mandatory
      !--- The "H:M:S" field is optional
      write(6,'(3a)')"parse_time_units: Invalid time_units string --> ",trim(time_units_in)," <--"
      call xit("PARSE_TIME_UNITS",-2)
    endif

    !--- Process each word to extract time units and origin
    do idx1=1,nword
      select case (idx1)
        case (1)
          !--- This should be the units string
          time_units = " "
          time_units = trim(word(idx1))
          !--- Set time_units explicitly in the following case statement so
          !--- that regardless of the abbreviation, time_units will always
          !--- contain a know string which may be compared later on
          select case (trim(adjustl(time_units)))
            case ("y", "year", "years")
              time_units = "years"
            case ("d", "day", "days")
              time_units = "days"
            case ("h", "hr", "hrs", "hour", "hours")
              time_units = "hours"
            case ("m", "min", "mins", "minute", "minutes")
              time_units = "minutes"
            case ("s", "sec", "secs", "second", "seconds")
              time_units = "seconds"
            case default
              !--- Invalid time units
              write(6,'(3a)')"parse_time_units: Invalid time units --> ", &
                trim(time_units_in)," <--"
              write(6,'(a)')" The first word must be one of days, hours, minutes, seconds."
              call xit("PARSE_TIME_UNITS",-3)
          end select
        case (2)
          !--- This should be the string "since"
          if (trim(adjustl(word(idx1))) .ne. "since" ) then
            !--- Abort if this is not "since"
            write(6,'(3a)')"parse_time_units: Invalid time units --> ", &
              trim(time_units_in)," <--"
            write(6,'(a)')' The second word must be "since".'
            call xit("PARSE_TIME_UNITS",-4)
          endif
        case (3)
          !--- This should be the date string in the form Y-M-D
          !--- call str2list(word(idx1),64,"-",numb,nnumb,3)
          call split_on_delim(numb,nnumb,word(idx1),"-")
          if (nnumb.ne.3) then
            write(6,'(3a)')"parse_time_units: Invalid time units --> ", &
              trim(time_units_in)," <--"
            write(6,'(3a)')" Invalid date field --> ", &
              trim(word(idx1))," <-- This field must be of the form Y-M-D."
            call xit("PARSE_TIME_UNITS",-5)
          endif
          do idx2=1,nnumb
            strng=" "
            strng=trim(adjustl(numb(idx2)))
            select case (idx2)
              case (1)
                read(strng,*)year
                if (year.lt.0) then
                  write(6,*)"parse_time_units: year is out of range. year=",year
                  call xit("PARSE_TIME_UNITS",-6)
                endif
              case (2)
                read(strng,*)mon
                if (mon.lt.1 .or. mon.gt.12) then
                  write(6,*)"parse_time_units: month is out of range. mon=",mon
                  call xit("PARSE_TIME_UNITS",-7)
                endif
              case (3)
                read(strng,*)day
                if (day.lt.1 .or. day.gt.31) then
                  write(6,*)"parse_time_units: day is out of range. day=",day
                  call xit("PARSE_TIME_UNITS",-8)
                endif
              case default
                !--- Too many fields
                write(6,*)"parse_time_units: Too many fields found in date string."
                write(6,*)"   ",trim(word(idx1))
                call xit("PARSE_TIME_UNITS",-9)
            end select
          enddo
        case (4)
          !--- This should be the time of day string in the form H:M:S
          !--- call str2list(word(idx1),64,":",numb,nnumb,3)
          call split_on_delim(numb,nnumb,word(idx1),":")
          if (nnumb.ne.3) then
            write(6,'(3a)')"parse_time_units: Invalid time units --> ", &
              trim(time_units_in)," <--"
            write(6,'(3a)')" Invalid time of day field --> ", &
              trim(word(idx1))," <-- This field must be of the form H:M:S."
            call xit("PARSE_TIME_UNITS",-10)
          endif
          do idx2=1,nnumb
            strng=" "
            strng=trim(adjustl(numb(idx2)))
            select case (idx2)
              case (1)
                read(strng,*)hour
                if (hour.lt.0 .or. hour.gt.24) then
                  write(6,*)"parse_time_units: hour is out of range. hour=",hour
                  call xit("PARSE_TIME_UNITS",-11)
                endif
              case (2)
                read(strng,*)min
                if (min.lt.0 .or. min.gt.60) then
                  write(6,*)"parse_time_units: minute is out of range. min=",min
                  call xit("PARSE_TIME_UNITS",-12)
                endif
              case (3)
                read(strng,*)sec
                if (sec.lt.0 .or. sec.gt.60) then
                  write(6,*)"parse_time_units: second is out of range. sec=",sec
                  call xit("PARSE_TIME_UNITS",-13)
                endif
              case default
                !--- Too many fields
                write(6,*)"parse_time_units: Too many fields found in time of day string."
                write(6,*)"   ",trim(word(idx1))
                call xit("PARSE_TIME_UNITS",-14)
            end select
          enddo
        case default
          !--- Too many words
          write(6,*)"parse_time_units: Too many words found in time_units string."
          write(6,*)"   ",trim(time_units_in)
          call xit("PARSE_TIME_UNITS",-15)
      end select
    enddo

    !--- By this point the parameters year, mon, day, hour, min, sec should have been
    !--- set appropriately. Now assign them to the global reference date/time array
    gref_ymd_hms(1) = year
    gref_ymd_hms(2) = mon
    gref_ymd_hms(3) = day
    gref_ymd_hms(4) = hour
    gref_ymd_hms(5) = min
    gref_ymd_hms(6) = sec

  end subroutine parse_time_units

end module time_subs
